<!--
@license
Copyright (c) 2016 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
-->

<link rel="import" href="redux-store.html">
<link rel="import" href="../bower_components/polymer/polymer-element.html">
<link rel="import" href="../bower_components/app-storage/app-localstorage/app-localstorage-document.html">
<link rel="import" href="../bower_components/iron-pages/iron-pages.html">
<link rel="import" href="../bower_components/iron-icons/iron-icons.html">
<link rel="import" href="../bower_components/iron-flex-layout/iron-flex-layout-classes.html">
<link rel="import" href="../bower_components/app-layout/app-grid/app-grid-style.html">

<link rel="import" href="collection-observer.html">
<link rel="import" href="product-card.html">

<dom-module id="admin-products">

  <template>
    <style include="app-grid-style">
    
        div[name="products"] {
          --app-grid-columns: 5;
          --app-grid-item-height: 400px;
        }
    
        ul {
          padding: 0;
          list-style: none;
        }
    
        .item {
          background-color: white;
        }
    
        @media (max-width: 640px) {
          :host {
            --app-grid-columns: 1;
          }
        } 
        #user-info
        {
          padding: 0 8px;
        }   
  </style>

    <paper-dialog id="productDlg">
        <paper-dialog-scrollable>
          <product-card id="product"><product-card>
        </paper-dialog-scrollable>
        <div class="buttons">
          <paper-button dialog-dismiss>Отмена</paper-button>
          <paper-button dialog-confirm autofocus on-tap="_removeProduct">Удалить</paper-button>
          <paper-button dialog-confirm autofocus on-tap="_saveProduct">Сохранить</paper-button>
        </div>
    </paper-dialog>

    <collection-observer name="products" subscribed></collection-observer>
      
      <div name="products">   
        <paper-button class="action-add" on-tap="_add">Новый продукт</paper-button>       
        <paper-tabs selected="{{productCategory}}" attr-for-selected="name">
            <template is="dom-repeat" items="[[categories]]">
                <paper-tab name=[[item.name]]><h2>[[item.title]]</h2></paper-tab>
            </template>
        </paper-tabs> 
        <ul class="app-grid">        
          <dom-repeat items="[[_products(productCategory,refresh)]]" initial-count="16" sort="_sortByTimestamp">
              <template>
                <li>                    
                    <food-list-item item="[[item]]" availability on-tap="_editProduct">
                    </food-list-item>                    
                </li>
              </template>
            </dom-repeat>
        </ul>
      </div>
      



    <!-- > Product ( category, type , business logic of client )

    > Order ( flow , state )  - Cart = creates order, user just approve?(register)

    > Delivery  ( map, delivery position, user administration / user profiles ) -->

        
  </template>

  <script>

    class AdminProducts extends ReduxMixin(Polymer.Element) {

      static get is() { return 'admin-products'; }
      
      static get observers() {
        return ['_computeProducts(immutableProducts)']
    }
  
      static get properties() { return {
        categories: Array,
        
        dictionary:{
          type: Array,
          statePath: 'dev.dictionary'
        },        
        products: { 
            type: Array,
            value: []
          },
          immutableProducts: {
            type: Object,
            statePath: "products.items"
          },   
      
        productCategory: {
            type: String,
            value: defaultCategory.name
            },
      }}
      
      _sortByTimestamp( a, b) {

          a = new Date(a.timestamp);
          b = new Date(b.timestamp);
          return a>b ? -1 : a<b ? 1 : 0;
      };

      
      _products(category)
      {
        return _.filter(this.products,(p)=>p.category == category)
      }
      _computeProducts(immutable)
        {
            // console.log("#products",immutable)
            var array = _.values(immutable);
            if( array.length )
            {                
                var splices = Polymer.ArraySplice.calculateSplices(array, this.products);

                // Copy content
                this.products.length = 0;
                this.products.push(...array);

                // Inform Polymer about changes
                this.notifySplices('products', splices);  
                this.refresh = !this.refresh;
            }
        
        }
        _add()
        {
            this.$.product.reset();
            this.$.product.set('item.category',this.category);
            this.$.productDlg.open();
        }
        _editProduct(e)
        {          
          this.$.product.item = e.model.item;        
          this.$.productDlg.open();
        }
        _removeProduct()
        {
          Meteor.call('removeProduct', this.$.product.item._id)
          
        }
        _saveProduct(e)
        {
          var item = Object.assign( this.$.product.item, { timestamp: Date.now()})

          if( '_id' in this.$.product.item)      
            Meteor.call('updateProduct', item);
          else
            Meteor.call('addProduct', item);

            
        }

        connectedCallback() {
            super.connectedCallback();
            window.dev = this;

            Tracker.autorun(() => {
                Meteor.subscribe('products',()=>this.subscribed = true);
            });
            // console.log('food-orders created!');
        }
       
      


    }

    customElements.define(AdminProducts.is, AdminProducts);

  </script>

</dom-module>
